/*
 * Main.cpp
 *
 *  Created on: 22/06/2013
 *      Author: marcelo
 */

#include <cstdlib> // EXIT_FAILURE
#include <iostream> // cout
#include <fstream> // namespace ifstream
#include "Instancia.h"

using namespace std;

Instancia* lerArquivo(const char* nomeArquivo) {
	ifstream arquivo(nomeArquivo, ifstream::in);
	if (!arquivo.is_open()) {
		cout << "Não foi possível abrir \"" << nomeArquivo << "\"." << endl;
		return NULL;
	}

	int n = 0;
	if (arquivo.eof()) {
		cout << "O arquivo \"" << nomeArquivo << "\" está vazio." << endl;
		arquivo.close();
		return NULL;
	} else {
		arquivo >> n;
	}

	Instancia* I = new Instancia(n);
	int valor;

	// O arquivo tem n + 1 linhas e colunas, por isso i <= n, em vez de i < n.
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			if (arquivo.eof()) {
				cout << "O arquivo \"" << nomeArquivo << "\" está incompleto." << endl;
				arquivo.close();
				return NULL;
			} else {
				arquivo >> valor;
				I->set(i, j, valor);
			}
		}
	}

	arquivo.close();
	return I;
}

// TODO Remover. Listagem do conteúdo do arquivo, apenas para teste.
void exibirInstancia(Instancia* I) {
	cout << "Tamanho da instância: " << I->tamanho() << endl;
	cout << "Matriz: " << endl;
	for (int i = 0; i <= I->tamanho(); i++) {
		for (int j = 0; j <= I->tamanho(); j++) {
			cout << I->get(i, j) << "\t";
		}
		cout << endl;
	}
}

int main(int argc, char **argv) {
	if (argc < 2) {
		cout << "Sintaxe: t2 <nome do arquivo>" << endl;
		return EXIT_FAILURE;
	}

	Instancia* I = lerArquivo(argv[1]);

	if (I != NULL) {
		// TODO Remover. Listagem do conteúdo do arquivo, apenas para teste.
		exibirInstancia(I);
	}

	delete I;
	return EXIT_SUCCESS;
}
